# Risotto

## Installation

Install dependencies:

- ldns-utils
- python3-cheetah
- python3-dkimpy

Clone projects:

- https://framagit.org/tiramisu/tiramisu
- https://cloud.silique.fr/gitea/risotto/dataset
- https://cloud.silique.fr/gitea/risotto/rougail
- https://cloud.silique.fr/gitea/risotto/risotto

## Set up

Set up Risotto:

```bash
cd risotto
cp risotto.conf.example risotto.conf
```

In risotto.conf change the dataset directory.

Set up infrasctructure:

```bash
cp server.json.example server.json
```

Change the configuration.

Send configuration to remote server:

```bash
HOST=cloud.silique.fr
./test.py
rm -f installations.tar
tar -cf installations.tar installations
scp installations.tar root@$HOST:
```

## Deploy

In host:

```bash
cd
rm -rf installations
tar xf installations.tar
cd installations
```

Set up host:

```bash
./install_host cloud.silique.fr
```

Build container image:

```bash
./install_images cloud.silique.fr
```

Set up the containers and start them up:

```bash
./install_machines cloud.silique.fr
```
